#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include "config.h"

#define MAXTEXTL 64
#define MAXPATH  512
#define MAXLINES 32

int flines = 1;
int sunit = 0, sikev = 0;
char ftitle[MAXTEXTL]="default session";
double lambda[MAXLINES] = {18.97};
double sigma[MAXLINES] = {0.03};
double f[MAXLINES] = {0.0};
double v=0.;
double ap_s = 1., ap_b = 1.;
double s_bg = 0.;
int s_bgit = 0, bg_smooth = 1, i_sbgchi = 0, i_lamit = 1, i_sigit = 1, i_format = 0,
i_portrait = 0,  i_res = 0, i_plot = 1, fix_fl=0;
int i_errplot = 0, i_lab = 0, i_log = 0, n_bin = 1, i_spec_only=0,fit_only=0;
int n_lik = 0, i_spline = 0, id_lam = 1, id_sig = 0;
double d_sig = .02, d_lam = .5, i_ord = 1., i_medsig=3.;
int    pro_type[MAXLINES]={0};     /* the profile type          */
int    fit_wave[MAXLINES]={1};     /* whether to fit wavelength */
int    fit_sigm[MAXLINES]={1};     /* whether to fit sigme      */
int    fit_lock[MAXLINES]={0};     /* lock lambda to previous   */
float  beta[MAXLINES]={1.};        /* exponent in Beta model    */

float *wav, *flux;

/*  -------------------------------------------------------------------- */

double double_min (float * inArr, int size, int *index)
{
  int   i;
  float min = inArr[0];

  for (i = 0; i < size; ++i)
   if (min > inArr[i])
     {
        min = inArr[i];
        *index = i;
     }

  return min;
}

/*  -------------------------------------------------------------------- */

double double_max (float * inArr, int size, int *index)
{
  int   i;
  float max = inArr[0];

  for (i = 0; i < size; ++i)
   if (max < inArr[i])
     {
        max = inArr[i];
        *index = i;
     }
  return max;
}

/*  -------------------------------------------------------------------- */

void
make_inputfile (char *path)
{
  FILE *fd;
  int i = 0;

  fd = fopen (path, "w");

  fprintf (fd, "%s            ; %s\n", VERSION,"Version");
  fprintf (fd, "%s\n", ftitle);
  fprintf (fd, "%d              ; %s\n", flines,"number of lines");
  for (i = 0; i < flines; ++i)
    fprintf (fd, "%5.3f,%5.4f,%5.4f,%d,%d,%d,%d,%5.3f ; %s_%d, %s_%d, %s_%d %s_%d\n",
	     lambda[i], sigma[i], f[i],
	     pro_type[i], fit_wave[i], fit_sigm[i], fit_lock[i],beta[i],
	     "lambda",i,"sigma",i,"f",i,
	     "Flags: Profile, FitLambda, FitSigma, LockLambda, Bet",i);
  fprintf (fd, "%4.2f,%4.2f,%4.2f,%d       ; %s\n", ap_s, ap_b,v,fix_fl,"App(source),App(BG),v,fixflag");
  fprintf (fd, "%f,%d,%d,%d,%4.2f   ; %s\n", s_bg, s_bgit, bg_smooth,i_sbgchi,i_medsig,"source background [cts/A],=1:iterate sbg,=1 smooth background,iter. sbg with chi^2,median sbg range");
  fprintf (fd, "%5.4f,%d,%5.4f,%d           ; %s\n", d_sig, sunit, d_lam, sikev,"dsig, unit(sig), dlam, ikev");
  fprintf (fd, "%d,%d,%5.3f,%d   ; %s\n", i_lamit,id_lam,i_ord,id_sig,"ilamit, idlam,iord,idsig");
  fprintf (fd, "%d              ; %s\n", i_sigit,"isigit(=1 automatic iteration in sigma)");
  fprintf (fd, "%d              ; %s\n", i_res,"ires=1 print results into file ");
  fprintf (fd, "%d,%d            ; %s\n", i_format,i_portrait,"iformat: 0: X-window, 1: PS, 2:GIF, 3: PPM, iportrait for orientation");
  fprintf (fd, "%d,%d,%d,%d,%d,%d,%d    ; %s\n", i_plot, i_lab, i_errplot, i_log, n_bin,i_spec_only,fit_only,"iplot,ilab,ierrplot,ilog,nbin,spec_only,fit_only");
  fprintf (fd, "%d,%d            ; %s\n", n_lik, i_spline,"nlik, ispline (not supported by C program)");


fprintf (fd, "#\n#\n#%s\n"," **                 parameters and variables");
fprintf (fd, "#%s\n"," ** variable names of input data comprehensive for the program");
fprintf (fd, "#\n");
fprintf (fd, "#%s\n","   Version		: Version number (cf. config.h)");
fprintf (fd, "#%s\n","   fittitle 		: title for plot");
fprintf (fd, "#%s\n","   nlines		: number of lines to be modeled");
fprintf (fd, "#%s\n","   lam1,sig1,f1,pro_typ1,FitLam1,FitSig1,LockLam1	:");
fprintf (fd, "#%s\n","		 start values/flags for first line");
fprintf (fd, "#%s\n","   lam2,sig2,f2,pro_typ2,FitLam2,FitSig2,LockLam2	:");
fprintf (fd, "#%s\n","		 start values/flags for second line");
fprintf (fd, "#%s\n","     .    .");
fprintf (fd, "#%s\n","     .    .");
fprintf (fd, "#%s\n","   lam_N,sig_N,fN,pro_typN,FitLamN,FitSigN,LockLamN	:");
fprintf (fd, "#%s\n","		 start values/flags for last line");
fprintf (fd, "#%s\n","   FitLam, FitSig	: flags for activating iteration for each individual line");
fprintf (fd, "#%s\n","   pro_typ		: select type of profile (=0 Gauss, =1 Lorentz");
fprintf (fd, "#%s\n","   LockLam		: Set Lambda value to value of proceding line (no effect for first line)");
fprintf (fd, "#%s\n","  		used for creating Voigt profile from Lorentz and Gauss profile");
fprintf (fd, "#%s\n","   Beta			: Exponent in denominator of Lorentz profile (Beta function");
fprintf (fd, "#%s\n","   App(source),App(BG)	: apertures for source spectrum");
fprintf (fd, "#%s\n","     			    and for background spectrum");
fprintf (fd, "#%s\n","   f1,..,fN		: array with weight factors for auxiliary conditions");
fprintf (fd, "#%s\n","   v			: in the form sum(f_i*ampout_i)=v");
fprintf (fd, "#%s\n","   fixflag             : switch decides whether badly binned spectra will be fixed ( empty bins filled with zeros)");
fprintf (fd, "#%s\n","   sbg,sbgit,bgsmooth,sbgchi : value for source backkground [cts/A],");
fprintf (fd, "#%s\n","     			   switch for iterating sbg,");
fprintf (fd, "#%s\n","     			   switch for smoothing background");
fprintf (fd, "#%s\n","                             switch for iterating sbg using chi^2 minimization\n");
fprintf (fd, "#%s\n","   dsig, unit(sig), dlam, ikev:");
fprintf (fd, "#%s\n","     			  range for sigma,");
fprintf (fd, "#%s\n","     			   units for sigma (=0 -> Angstroem else km/s");
fprintf (fd, "#%s\n","     			   range for lambda");
fprintf (fd, "#%s\n","     			  ranges are drawn around each line");
fprintf (fd, "#%s\n","                             wavelengths scale in plot (=1 for keV else Angstroem)");
fprintf (fd, "#%s\n","  ilamit,idlam,iord,idsig: ");
fprintf (fd, "#%s\n","                          switch for iteration of lambda");
fprintf (fd, "#%s\n","			  switch for iterating only position of multiplet");
fprintf (fd, "#%s\n","			   but keeping distances between the lines constant");
fprintf (fd, "#%s\n","                          factor to multiply all wavelengths with");
fprintf (fd, "#%s\n","                           designed for higher dispersion orders (CHANDRA),");
fprintf (fd, "#%s\n","		          but possibly useful for reddening");
fprintf (fd, "#%s\n","                    switch for iterating all the same sigmas for all lines");
fprintf (fd, "#%s\n","   isigit		: switch for iteration of sigma");
fprintf (fd, "#%s\n","   iformat		: integer value indicating output format for plot");
fprintf (fd, "#%s\n","   ires		: write results into an ASCII file");
fprintf (fd, "#%s\n","                   indicated with option -o [default: cora.dat]");
fprintf (fd, "#%s\n","   iportrait		: switch for plotting in portrait format");
fprintf (fd, "#%s\n","     			  (=1 -> portrait =0 -> landscape)");
fprintf (fd, "#%s\n","   iplot		: switch for creating a plot");
fprintf (fd, "#%s\n","   ilab		: switch for putting lables into the plot");
fprintf (fd, "#%s\n","   ierrplot		: switch for including error bars in plot");
fprintf (fd, "#%s\n","   ilog		: switch for plotting semi logarithmic (y-axis)");
fprintf (fd, "#%s\n","   nbin		: integer value for binning:");
fprintf (fd, "#%s\n","                            binsze=nbin*(best resolution)");
fprintf (fd, "#%s\n","   spec_only		: =1 plot only the spectrum; no fitting");
fprintf (fd, "#%s\n","   fit_only              : =1 plot only the fit, no spectrum");
fprintf (fd, "#%s\n","   nlik		: only supported by IDL program");
/*  fprintf (fd, "#%s\n","     			  lambda vs. liklihood and sigma vs. liklihood.");
fprintf (fd, "#%s\n","     			  nlik=0 -> no such plot (default)");  */
fprintf (fd, "#%s\n","   ispline		: only supported by IDL program");
 /* perform spline interpolation of liklihood curves"); */

  fclose  (fd);
  return;
}


/*  -------------------------------------------------------------------- */

int get_spec (char *path, int s_flag)
{
  FILE * fd;
  char line[BUFSIZ];
  int count_line = 0, items = 0, n_count=0;

  if (NULL == (fd = fopen(path, "r")))
    {
      printf("* Warning * %s: File not found.\n", path);
      return (-1);
    }

  while (fgets(line, BUFSIZ-1, fd))
    if (line[0] != '#') ++n_count;

  rewind(fd);

  wav = (float *) malloc (sizeof(float) * n_count);
  flux = (float *) malloc (sizeof(float) * n_count);

  if (wav == NULL || flux == NULL)
    {
      fprintf(stderr,"* Warning *: Out of memory\n");
      return(-1);
    }

  while (fgets(line, BUFSIZ-1, fd))
    {
      if (line[0] != '#')
        {
          items = sscanf(line, "%f %f",
                    &wav[count_line], &flux[count_line]);
          if (items == 2)
            ++count_line;
          else
            {
              printf("* Warning * %s: Invalid line: %s", path, line);
              free(wav); free(flux);
              return (-1);
            }
        }

     }
  if (count_line < n_count)
    {
      printf("* Warning * Race condition detected\n");
      free(wav); free(flux);
      return (-1);
    }

  return (n_count);
}

/*  -------------------------------------------------------------------- */

int main(int argc, char *argv[])
{

 FILE * fd;
double dummy=0.0,dummy2=0.0;
int i,index,n_count;
char datafile[MAXPATH];
char conffile[MAXPATH], usage[MAXPATH];
float *test,*test2;

strncpy (datafile, "spectrum.dat", MAXPATH);
strncpy (conffile, "fit.inp", MAXPATH);
strncpy (usage, "Usage: cora_inp [-help] [-s datafile] [-i conffile]\n", MAXPATH);

  while (argc > 1 && argv[1][0] == '-')
    {
      switch (argv[1][1])
        {
        case 's':
          ++argv;
          --argc;
          if (argc == 1)
            {
              fprintf (stderr, usage);
              exit (8);
            }
          strncpy (datafile, argv[1], MAXPATH);
          break;
        case 'i':
          ++argv;
          --argc;
          if (argc == 1)
            {
              fprintf (stderr, usage);
              exit (8);
            }
          strncpy (conffile, argv[1], MAXPATH);
          break;
        default:
          fprintf (stderr, usage);
          fprintf (stderr, "%s","datafile : spectrum with two, three, or five columns (default: spectrum.dat; can be created with cora_spec)\n");
          fprintf (stderr, "%s","conffile : resulting configuration file (default: fit.inp)\n");
          fprintf (stderr, "%s","\n");
	  exit(8);
          break;
        }
      ++argv;
      --argc;
    }




  /*  define default wavelength and default sigma
   */
    if (NULL== (fd=fopen(datafile,"r"))) 
    {
      printf("* Warning * %s: File not found.\n", datafile);
      return(-1);
    } 
    else fclose(fd);

    n_count=get_spec(datafile,0);

    test = (float *) malloc (sizeof(float) * n_count);

    for (i=0;i<n_count;++i) dummy+=flux[i];
    dummy /=n_count;

    for (i=0;i<n_count;++i)
	test[i]=fabs(flux[i]-dummy);

    dummy = double_max(test,n_count,&index);
    lambda[0] = wav[index];
    while(test[index]>dummy/2.) --index;

    sigma[0] = lambda[0]-wav[index];
    d_sig = sigma[0]*0.9;
    d_lam = 15*d_sig;

    test2 = (float *) malloc (sizeof(float) * flines);
    for (i=0;i<n_count;++i)
      test[i]=wav[i];
    dummy=double_max(test,n_count,&i);
    for (i=0;i<flines;++i)
      test2[i]=lambda[i];
    dummy2=double_max(test2,flines,&i);

   if(dummy2+d_lam > dummy)
     d_lam=dummy-dummy2;
    for (i=0;i<n_count;++i)    
      test[i]=wav[i];
    dummy=double_min(test,n_count,&i);
    for (i=0;i<flines;++i)
      test2[i]=lambda[i];
    dummy2=double_min(test2,flines,&i);
   if(dummy2-d_lam < dummy)
     d_lam=dummy2-dummy;

    make_inputfile (conffile);

    free(wav); free(flux);

return (0);
}


