#include "Cora.h"
#include <stdlib.h>

void
create_frame (GtkWidget * vbox, GtkWidget * box_loop, char *title)
{
  GtkWidget *frame;
  frame = gtk_frame_new (title);

  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, FALSE, 2);
  gtk_container_add (GTK_CONTAINER (frame), box_loop);

  gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_ETCHED_OUT);
  gtk_widget_show (frame);

  return;
}

/*  -------------------------------------------------------------------- */

GtkWidget *
create_entry (GtkWidget * box_loop, void *enter_callback, char *callarg,
              char *deftext, char *labtext)
{
  GtkWidget *box_tmp = NULL;
  GtkWidget *entry;
  GtkWidget *label;

  box_tmp = gtk_vbox_new (FALSE, 0);
  label = gtk_label_new (labtext);
  gtk_widget_show (label);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);
  gtk_box_pack_start (GTK_BOX (box_tmp), label, FALSE, FALSE, 0);

  entry = gtk_entry_new_with_max_length (MAXTEXTL);

  gtk_signal_connect (GTK_OBJECT (entry), "changed",
                      GTK_SIGNAL_FUNC (enter_callback), callarg);
  gtk_entry_set_text (GTK_ENTRY (entry), deftext);

  gtk_entry_select_region (GTK_ENTRY (entry),
                           0, GTK_ENTRY (entry)->text_length);
  gtk_box_pack_start (GTK_BOX (box_tmp), entry, FALSE, FALSE, 0);

  gtk_box_pack_start (GTK_BOX (box_loop), box_tmp, TRUE, FALSE, 0);
  gtk_widget_show (box_tmp);
  gtk_widget_show (box_loop);
  gtk_widget_show (entry);

  return (entry);
}

/*  -------------------------------------------------------------------- */

GtkWidget *
create_toggle (GtkWidget * box_loop, void *enter_switch, char *callarg,
               char *deftext, char *labtext)
{
  GtkWidget *toggle;

  toggle = gtk_check_button_new_with_label (labtext);
  gtk_signal_connect (GTK_OBJECT (toggle), "clicked",
                      GTK_SIGNAL_FUNC (enter_switch), callarg);

  gtk_box_pack_start (GTK_BOX (box_loop), toggle, TRUE, FALSE, 0);

  if (atoi (deftext) == 1)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (toggle), TRUE);
  gtk_widget_show (box_loop);
  gtk_widget_show (toggle);

  return (toggle);
}

/*  -------------------------------------------------------------------- */

GtkWidget *
create_spin (GtkWidget * box_loop, GtkAdjustment * adj,
             void *enter_spin, char *callarg, char *labtext)
{
  GtkWidget *box_tmp = NULL;
  GtkWidget *label;
  GtkWidget *spinbutton;

  box_tmp = gtk_vbox_new (FALSE, 0);
  label = gtk_label_new (labtext);
  gtk_widget_show (label);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);
  gtk_box_pack_start (GTK_BOX (box_tmp), label, TRUE, FALSE, 0);

  spinbutton = gtk_spin_button_new (adj, 0.0, 0);
  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spinbutton), TRUE);
  gtk_widget_set_usize (spinbutton, 100, 0);
  gtk_box_pack_start (GTK_BOX (box_tmp), spinbutton, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (box_loop), box_tmp, TRUE, FALSE, 0);

  gtk_widget_show (spinbutton);
  gtk_widget_show (box_tmp);
  gtk_widget_show (box_loop);
  gtk_signal_connect (GTK_OBJECT (spinbutton), "changed",
                      GTK_SIGNAL_FUNC (enter_spin), callarg);

  return (spinbutton);
}
/*  -------------------------------------------------------------------- */

GtkWidget *
create_spin_float (GtkWidget * box_loop, GtkAdjustment * adj,
             void *enter_spin, char *callarg, char *labtext)
{
  GtkWidget *box_tmp = NULL;
  GtkWidget *label;
  GtkWidget *spinbutton;

  box_tmp = gtk_vbox_new (FALSE, 0);
  label = gtk_label_new (labtext);
  gtk_widget_show (label);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);
  gtk_box_pack_start (GTK_BOX (box_tmp), label, TRUE, FALSE, 0);

  spinbutton = gtk_spin_button_new (adj, 0.0, 3);
  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spinbutton), TRUE);
  gtk_widget_set_usize (spinbutton, 100, 0);
  gtk_box_pack_start (GTK_BOX (box_tmp), spinbutton, TRUE, FALSE, 0);
  gtk_box_pack_start (GTK_BOX (box_loop), box_tmp, TRUE, FALSE, 0);

  gtk_widget_show (spinbutton);
  gtk_widget_show (box_tmp);
  gtk_widget_show (box_loop);
  gtk_signal_connect (GTK_OBJECT (spinbutton), "changed",
                      GTK_SIGNAL_FUNC (enter_spin), callarg);

  return (spinbutton);
}

